﻿using System;
using LogService;
using Ninject;
using Ninject.Modules;
using NinjectApp.Warrior;
using NinjectApp.Weapon;

namespace NinjectApp
{
    class Program
    {
        private static readonly NinjectModule module = new ServiceModule();

        static void Main(string[] args)
        {
            InjectManual();//手动注入

            InjectByConfig();//配置注入

            Console.Read();
        }

        /// <summary>
        /// 手动注入
        /// </summary>
        static void InjectManual()
        {
            using (var kernel = new StandardKernel(module))
            {
                var dbLogger = kernel.Get<ILogService>();
                dbLogger.AppendLog("hello world");

                var weapon = kernel.Get<IWeapon>();
                Console.WriteLine(weapon.GetType());
                Console.WriteLine(weapon.Name);

                //weapon = kernel.Get<Shuriken>();
                //Console.WriteLine(weapon.GetType());
                //Console.WriteLine(weapon.Name);

                var weapon1 = kernel.Get<IWeapon>();
                Console.WriteLine(weapon1.GetType());
                Console.WriteLine(weapon1.Name);

                Console.WriteLine(object.ReferenceEquals(weapon, weapon1));

                var warrior = kernel.Get<IWarrior>();
                Console.WriteLine(warrior.GetType());
            }

        }

        /// <summary>
        /// 通过xml配置注入
        /// </summary>
        static void InjectByConfig()
        {
            var kernel = XmlServiceModule.GetKernel();
            var logger = kernel.Get<ILogService>();
            Console.WriteLine(logger.GetType());
            logger.AppendLog("hello world");
           
            var weapon = kernel.Get<IWeapon>();
            Console.WriteLine(weapon.GetType());
            Console.WriteLine(weapon.Name);

            var warrior = kernel.Get<IWarrior>();
            Console.WriteLine(warrior.GetType());
        }

    }
}
